
               Rem LICZNIK CZASU


Config Timer0 = Timer Gate = Internal , Mode = 1
Declare Sub Write_eeprom                                      'deklaracja podprogramu odczytu danych z EEPROMu
Declare Sub Read_eeprom                                       'deklaracja podprogramu zapisu danych do EEPROMu
Declare Sub Ledd                                              'deklaracja podprogramu ledd
Declare Sub Dziel                                             'deklaracja podprogramu dziel
Declare Sub Op                                                'deklaracja podprogramu Op
Declare Sub Klawiatura                                        'deklaracja podprogramu klawiatura
Declare Sub Prog
Declare Sub Wy                                                'deklaracja podprogramu wy
Dim K As Byte                                                 ' deklaracja zmiennej
Dim Adres As Byte                                             ' deklaracja zmiennej
Dim Value As Byte                                             ' deklaracja zmiennej
Dim Counts As Word                                            ' deklaracja zmiennej
Dim Temp As Byte                                              ' deklaracja zmiennej
Dim Tem As Word                                               ' deklaracja zmiennej
Dim Wyl As Word                                               ' deklaracja zmiennej
Dim Minuty As Byte                                            ' deklaracja zmiennej
Dim Godziny As Byte                                           ' deklaracja zmiennej
Dim Dni As Byte                                               ' deklaracja zmiennej
Dim Godz As Byte                                              ' deklaracja zmiennej
Dim S As Byte                                                 ' deklaracja zmiennej
Dim Sekundy As Byte                                           ' deklaracja zmiennej
Dim W As Byte                                                 ' deklaracja zmiennej
Dim X As Byte                                                 ' deklaracja zmiennej
Dim Y As Byte                                                 ' deklaracja zmiennej
Dim D As Byte                                                 ' deklaracja zmiennej
Declare Sub Write_eeprom (adres As Byte , Value As Byte)
On Timer0 Timer0_int                                          'deklaracja podprogramu obsugi timera0
Enable Timer0                                                 'zezwolenie na obsug przerwa z timera0
Enable Interrupts                                             ' zezwolenie globalne
Config Sda = P3.5
Config Scl = P3.7
Dim Cyfra(10) As Byte                                         'deklaracja tablicy
Cyfra(1) = 17                                                 'definicja wywietlanej cyfry "0"
Cyfra(2) = 248                                                'definicja wywietlanej cyfry "1"
Cyfra(3) = 35                                                 'definicja wywietlanej cyfry "2"
Cyfra(4) = 97                                                 'definicja wywietlanej cyfry "3"
Cyfra(5) = 201                                                'definicja wywietlanej cyfry "4"
Cyfra(6) = 69                                                 'definicja wywietlanej cyfry "5"
Cyfra(7) = 5                                                  'definicja wywietlanej cyfry "6"
Cyfra(8) = 241                                                'definicja wywietlanej cyfry "7"
Cyfra(9) = 1                                                  'definicja wywietlanej cyfry "8"
Cyfra(10) = 65
Counts = 0
Sekundy = 0                                                   'zmienna sekundy przyjmuje warto 0
S = 0                                                         'zmienna s przyjmuje warto 0
Tem = 0                                                       'zmienna tem przyjmuje warto 0
Wyl = 0                                                       'zmienna wyl przyjmuje warto 0
K = 0                                                         'zmienna k przyjmuje warto 0
Set P3.4                                                      ' ustawienie stanu wysokiego na P3.4
Do
Adres = 1                                                     'podanie adresu odczytu minut z pamici
Call Read_eeprom                                              'skok do podprogramu odczytu z pamici
Minuty = Value
Adres = 2                                                     'podanie adresu odczytu godzin z pamici
Call Read_eeprom                                              'skok do podprogramu odczytu z pamici
Godziny = Value
Adres = 3                                                     'podanie adresu odczytu dni z pamici
Call Read_eeprom                                              'skok do podprogramu odczytu z pamici
Dni = Value
Call Prog                                                     'skok do podprogramu prog
 Loop

Sub Prog:                                                     'podprogram prog (gwny)
Do                                                            'pocztek pentli programowej
If K = 1 Then                                                 'jeeli k=1
If Wyl < 1000 Then                                            ' jeeli wyl<1000
Set P3.4                                                      ' ustawienie stanu wysokiego na P3.4
End If                                                        'koniec warunku
End If                                                        'koniec warunku

Call Klawiatura                                               'skok do podprogramu obsugi klawiatury
If K = 0 Then                                                 'jeeli k=0
Stop Timer0                                                   'to zatrzymaj timer0
Call Wy                                                       'skok do podprogramu sterujcym sposobem wywietlania czasu
Incr Wyl                                                      'zwiksz wyl o 1
If Wyl > 1000 Then                                            'jeeli wyl> 1000
P3.4 = 0                                                      'ustaw stan niski na P3.4
Else                                                          'przeciwnym wypadku
P3.4 = 1                                                      'ustaw stan wysoki na P3.4
End If                                                        'koniec warunku
End If                                                        'koniec warunku

If K = 1 Then                                                 'jeeli k=1
Start Timer0                                                  'wcz timer0
If Wyl < 4000 Then                                            'jeeli wy<4000 to
Incr Wyl                                                      'zwiksz zmienn wyl o 1
Call Wy                                                       'skok do podprogramu sterujcym sposobem wywietlania czasu
End If                                                        'koniec warunku
End If                                                        'koniec warunku
Loop                                                          'koniec ptli
End Sub                                                       'koniec podprogramu

Timer0_int:                                                   'podprogram obsugi timera0
Counter0 = 4150
Start Timer0                                                  'wczenie timera0                                               '
Incr Counts                                                   'zwikszenie zmiennej counts o 1
If Counts > 15 Then
Counts = 0                                                    'counts=0       'jeeli counts >15 to
Incr Sekundy                                                  'zwiksz a o 1
If Sekundy > 59 Then                                          'jeeli a>59 to
Sekundy = 0                                                   'sekundy=0
Incr Minuty                                                   'zwiksz minuty o 1
Value = Minuty
Adres = 1                                                     'podanie adresu zapisu minut do pamici
Call Write_eeprom                                             'skok do podprogramu zapisu danych do pamici
If Minuty > 59 Then                                           'jeeli minuty > 59 to
Incr Godziny                                                  'zwiksz godziny o 1
Minuty = 0
Value = Godziny
Adres = 2                                                     'podanie adresu zapisu godzin w pamici
Call Write_eeprom                                             'skok do podprogramu zapisu danych
End If                                                        'koniec warunku
If Godziny > 23 Then                                          'jeeli godzina > 23 to
Incr Dni                                                      'zwiksz dni o 1
Godziny = 0
Value = Dni
Adres = 3                                                     'podanie adresu zapisu godzin
Call Write_eeprom                                             'skok do podprogramu zapisu danych
End If                                                        'koniec warunku
End If                                                        'koniec warunku
End If                                                        ' koniec warunku
Return                                                        'powrt do programu

Sub Wy                                                        'podprogram wy
Incr Tem                                                      'zwiksz tem o 1
If Tem < 800 Then                                             'jeeli tem < 800 to
X = Sekundy                                                   'wywietlaj na wywietlaczu LED sekundy
Y = X
Call Ledd                                                     'skok do podprogramu obsugi wywietlacza LED
Incr S                                                        'zwiksz s o 1
X = Minuty                                                    'wywietlaj na wywietlaczu minuty
Y = X
Call Ledd                                                     'skok do podprogramu obsugi wywietlacza LED
End If                                                        'koniec warunku

If Tem > 800 Then                                             'jeeli tem > 800 to
X = Godziny                                                   'wywietlaj na wywietlaczu LED godziny
Y = X
Call Ledd                                                     'skok do podprogramu obsugi wywietlacza LED
Incr S                                                        'zwiksz s o 1
X = Dni                                                       'wywietlaj na wywietlaczu LED dni
Y = X
Call Ledd                                                     'skok do podprogramu obsugi wywietlacza LED
End If                                                        'koniec warunku
If Tem > 1000 Then
Tem = 0
End If                                                        'koniec warunku
End Sub                                                       'koniec podprogramu

Sub Klawiatura                                                'podprogram obsugi klawiatury
Reset P1.0                                                    'ustaw stan niski na P1.0
Set P3.2                                                      'ustaw stan wysoki na P3.2
If P3.2 = 0 Then                                              'jeeli zosta wcinity przycisk SW2 to
Incr K                                                        'zwiksz k o 1
Wyl = 0
End If                                                        ' koniec warunku
While P3.2 = 0                                                'poczekaj na opuszczenie przycisku SW2
Wend
If K > 1 Then                                                 'jeeli k >1 to
K = 0                                                         ' k=o
End If                                                        'koniec warunku
P3.2 = 0
Set P3.3
If P3.3 = 0 Then                                              'jeeli zosta wcinity przycisk SW3 i
If K = 0 Then                                                 'jeeli k = 0 to wyzeruj stan licznika
Sekundy = 0
Value = 0
Adres = 1
Call Write_eeprom
Value = 0
Adres = 2
Call Write_eeprom
Value = 0
Adres = 3
Call Write_eeprom
 Adres = 1
Call Read_eeprom
Minuty = Value
Adres = 2
Call Read_eeprom
Godziny = Value
Adres = 3
Call Read_eeprom
Dni = Value
While P3.3 = 0                                                'poczekaj na zwolnienie przycisku SW3
Wend
End If                                                        'koniec warunku
End If                                                        ' koniec warunku
P3.3 = 0
Set P3.3
If P3.3 = 0 Then                                              'jeeli zosta wcinity przycisk SW3 i
If K = 1 Then                                                 'jeeli k=1 to wcz wywietlacz LED
Wyl = 0
End If                                                        'koniec warunku
End If                                                        'koniec warunku
End Sub                                                       'koniec podprogramu

Sub Read_eeprom                                               'program odczytu danych z EEPROM
 I2cstart                                                     'inicjalizacja magistrali I2C
 I2cwbyte 160                                                 'podanie adresu pamici
 I2cwbyte Adres                                               'podanie adresu komrki pamici EEPROM
 I2cstart                                                     'powtrna inicjalizacja magistrali I2C
 I2cwbyte 161                                                 'zgoszenie danie odczytu zawartoci pamici
 I2crbyte Value , Nack                                        'odczytanie waciwego bajtu danych (z potwierdzeniem)
 I2cstop
End Sub

Sub Write_eeprom(adres As Byte , Value As Byte)               'podprogram zapisu danych do EEPROM
 I2cstart                                                     'inicjalizacja magistrali I2C
 I2cwbyte 160                                                 'podanie adresu pamici
 I2cwbyte Adres                                               'podanie adresu komrki pamici EEPROM
 I2cwbyte Value                                               'warto, ktra ma zosta zapisana
 I2cstop                                                      'zatrzymanie transmisji
 Waitms 10                                                    'pauza 10 ms dla zapisu danych w pamici
End Sub

Sub Ledd:                                                     'podprogram obsugi wywietlacza LED
D = 0
P1 = 255                                                      'ustawienie na porcie P1 stanw wysokich
W = 10
Call Dziel                                                    'skok do podprogramu dziel
If S = 0 Then                                                 'jeeli s=0 to
P3.0 = 0                                                      'ustaw odpowiednie stany na odpowiednich pinach
P3.1 = 0
P3.2 = 1
P3.3 = 0
End If                                                        'koniec warunku
If S = 1 Then                                                 'jeeli s=1 to
P3.0 = 0                                                      'ustaw odpowiednie stany na odpowiednich pinach
P3.1 = 1
P3.2 = 0
P3.3 = 0
End If                                                        ' koniec warunku
Call Op                                                       'skok do podprogramu op
W = 1
Call Dziel                                                    'skok do podprogramu dziel
If S = 0 Then                                                 'jeeli s=0 to
P3.0 = 0                                                      'ustaw odpowiednie stany na odpowiednich pinach
P3.1 = 0
P3.2 = 0
P3.3 = 1
End If                                                        'koniec warunku
If S = 1 Then                                                 'jeeli s=1 to
P3.0 = 1                                                      'ustaw odpowiednie stany na odpowiednich pinach
P3.1 = 0
P3.2 = 0
P3.3 = 0
S = 0
End If                                                        'koniec warunku
Waitms 2                                                      'poczekaj 2 milisekundy
P1 = 255
End Sub                                                       'koniec podprogramu

Sub Dziel                                                     'podprogram dziel
X = X \ W
D = X + 1
P1 = Cyfra(d)                                                 'wywietlenie cyfry d na odpowiednim wywietlaczu LED
 End Sub                                                      'koniec podprogramu

Sub Op                                                        'podprogram op
Waitms 2                                                      'poczekaj 2 milisekundy
X = X * W
X = Y -  X
Y = X
P1 = 255
End Sub                                                       'koniec podprogramu


